import * as i0 from '@angular/core';
import { Injectable, Component, Input, ViewChild, ViewEncapsulation, Directive, HostListener, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import * as i1 from '@ionic/angular';
import { IonicModule } from '@ionic/angular';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';

class NgxIonicImageViewerService {
    constructor() { }
}
NgxIonicImageViewerService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.8", ngImport: i0, type: NgxIonicImageViewerService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
NgxIonicImageViewerService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.2.8", ngImport: i0, type: NgxIonicImageViewerService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.8", ngImport: i0, type: NgxIonicImageViewerService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class ViewerModalComponent {
    constructor(modalController) {
        this.modalController = modalController;
        // tslint:disable: no-inferrable-types
        this.alt = '';
        this.scheme = 'auto';
        this.slideOptions = {};
        this.srcFallback = '';
        this.srcHighRes = '';
        this.swipeToClose = true;
        this.text = '';
        this.title = '';
        this.titleSize = '';
        // tslint:enable: no-inferrable-types
        this.defaultSlideOptions = {
            centeredSlides: true,
            passiveListeners: false,
            zoom: {
                enabled: true,
            },
        };
        this.options = {};
        this.swipeState = {
            phase: 'init',
            direction: 'none',
            swipeType: 'none',
            startX: 0,
            startY: 0,
            distance: 0,
            distanceX: 0,
            distanceY: 0,
            threshold: 150,
            restraint: 100,
            allowedTime: 500,
            elapsedTime: 0,
            startTime: 0,
        };
    }
    async ngOnInit() {
        this.options = { ...this.defaultSlideOptions, ...this.slideOptions };
        this.src = this.srcHighRes || this.src;
        this.setStyle();
        this.setScheme(this.scheme);
        this.initSwipeToClose(this.swipeToClose);
        /**
         * Current Workaround
         * See reported bug: https://github.com/ionic-team/ionic/issues/19638#issuecomment-584828315
         * Hint: Comment in '<ion-slide>' in component
         */
        // const swiper = await this.slides.getSwiper();
        // swiper.appendSlide(`<img alt="${this.alt}" src="${this.src}" onerror="this.src='${this.srcFallback}'"/>`);
    }
    setStyle() {
        const el = document.querySelector('.ion-img-viewer');
        el?.style.setProperty('--height', '100%');
        el?.style.setProperty('--width', '100%');
        el?.style.setProperty('--border-radius', '0');
    }
    setScheme(scheme) {
        if (scheme && scheme === 'auto') {
            return;
        }
        const el = document.querySelector('.ion-img-viewer');
        if (this.scheme === 'light') {
            el?.style.setProperty('--ion-background-color', '#ffffff');
            el?.style.setProperty('--ion-background-color-rgb', '255, 255, 255');
            el?.style.setProperty('--ion-text-color', '#000');
            el?.style.setProperty('--ion-text-color-rgb', '0,0,0');
        }
        if (this.scheme === 'dark') {
            if (el?.classList.contains('ios')) {
                el?.style.setProperty('--ion-background-color', '#000000');
                el?.style.setProperty('--ion-background-color-rgb', '0, 0, 0');
            }
            else {
                el?.style.setProperty('--ion-background-color', '#121212');
                el?.style.setProperty('--ion-background-color-rgb', '18,18,18');
            }
            el?.style.setProperty('--ion-text-color', '#ffffff');
            el?.style.setProperty('--ion-text-color-rgb', '255,255,255');
        }
    }
    /**
     * @see http://www.javascriptkit.com/javatutors/touchevents3.shtml
     */
    initSwipeToClose(isActive = true) {
        if (!isActive) {
            return;
        }
        const el = document.querySelector('ion-modal');
        el?.addEventListener('mousedown', (event) => this.swipeStart(event), true);
        el?.addEventListener('mousemove', (event) => this.swipeMove(event), true);
        el?.addEventListener('mouseup', (event) => this.swipeEnd(event), true);
        el?.addEventListener('touchstart', (event) => this.swipeStart(event), true);
        el?.addEventListener('touchmove', (event) => this.swipeMove(event), true);
        el?.addEventListener('touchend', (event) => this.swipeEnd(event), true);
        this.modalController.getTop().then((modal) => {
            modal?.onWillDismiss().then(() => {
                document.removeEventListener('mousedown', this.swipeStart, true);
                document.removeEventListener('mousemove', this.swipeMove, true);
                document.removeEventListener('mouseup', this.swipeMove, true);
                document.removeEventListener('touchstart', this.swipeStart, true);
                document.removeEventListener('touchmove', this.swipeMove, true);
                document.removeEventListener('touchend', this.swipeMove, true);
            });
        });
    }
    swipeStart(event) {
        const { pageX, pageY } = event.type === 'touchstart' ? event.changedTouches[0] : event;
        this.swipeState = {
            ...this.swipeState,
            phase: 'start',
            direction: 'none',
            distance: 0,
            startX: pageX,
            startY: pageY,
            startTime: new Date().getTime(),
        };
    }
    swipeMove(event) {
        if (this.swipeState.phase === 'none') {
            return;
        }
        const { pageX, pageY } = event.type === 'touchmove' ? event.changedTouches[0] : event;
        // get horizontal dist traveled by finger while in contact with surface
        const distanceX = pageX - this.swipeState.startX;
        // get vertical dist traveled by finger while in contact with surface
        const distanceY = pageY - this.swipeState.startY;
        let direction;
        let distance;
        if (Math.abs(distanceX) > Math.abs(distanceY)) {
            // if distance traveled horizontally is greater than vertically, consider this a horizontal swipe
            direction = distanceX < 0 ? 'left' : 'right';
            distance = distanceX;
        }
        else {
            // else consider this a vertical swipe
            direction = distanceY < 0 ? 'up' : 'down';
            distance = distanceY;
        }
        this.swipeState = {
            ...this.swipeState,
            phase: 'move',
            direction,
            distance,
            distanceX,
            distanceY,
        };
        event.preventDefault();
    }
    swipeEnd(event) {
        if (this.swipeState.phase === 'none') {
            return;
        }
        const { allowedTime, direction, restraint, startTime, threshold, distanceX, distanceY } = this.swipeState;
        let swipeType;
        const elapsedTime = new Date().getTime() - startTime; // get time elapsed
        if (elapsedTime <= allowedTime) {
            // first condition for a swipe met
            if (Math.abs(distanceX) >= threshold && Math.abs(distanceY) <= restraint) {
                // 2nd condition for horizontal swipe met
                swipeType = direction; // set swipeType to either "left" or "right"
            }
            else if (Math.abs(distanceY) >= threshold && Math.abs(distanceX) <= restraint) {
                // 2nd condition for vertical swipe met
                swipeType = direction; // set swipeType to either "top" or "down"
            }
        }
        this.swipeState = {
            ...this.swipeState,
            phase: 'end',
            swipeType: swipeType ?? '',
        };
        if (swipeType === 'down') {
            return this.closeModal();
        }
    }
    closeModal() {
        this.modalController.dismiss();
    }
}
ViewerModalComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.8", ngImport: i0, type: ViewerModalComponent, deps: [{ token: i1.ModalController }], target: i0.ɵɵFactoryTarget.Component });
ViewerModalComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.8", type: ViewerModalComponent, selector: "ion-viewer-modal", inputs: { alt: "alt", scheme: "scheme", slideOptions: "slideOptions", src: "src", srcFallback: "srcFallback", srcHighRes: "srcHighRes", swipeToClose: "swipeToClose", text: "text", title: "title", titleSize: "titleSize" }, viewQueries: [{ propertyName: "slides", first: true, predicate: ["sliderRef"], descendants: true, static: true }], ngImport: i0, template: "<ion-header [ngClass]=\"{ 'no-title': title && title.length <= 0 }\">\n  <ion-toolbar>\n    <ion-buttons slot=\"primary\">\n      <ion-button (click)=\"closeModal()\">\n        <ion-icon slot=\"icon-only\" name=\"close\"></ion-icon>\n      </ion-button>\n    </ion-buttons>\n    <ion-title [size]=\"titleSize\">{{ title }}</ion-title>\n  </ion-toolbar>\n</ion-header>\n\n<ion-content [forceOverscroll]=\"false\">\n  <swiper-container [zoom]=\"true\">\n    <swiper-slide>\n      <img id=\"image-viewer-image\" [alt]=\"this.alt\" [src]=\"this.src\"/>\n    </swiper-slide>\n  </swiper-container>\n</ion-content>\n\n<ion-footer [ngClass]=\"{ 'no-text': text && text.length <= 0 }\">\n  <ion-toolbar class=\"ion-text-center\">\n    <ion-text>{{ text }}</ion-text>\n  </ion-toolbar>\n</ion-footer>\n", styles: ["ion-toolbar{--border-style: none;--background: rgba(var(--ion-background-color-rgb, (255, 255, 255)), .6);background:rgba(var(--ion-background-color-rgb, 255, 255, 255),.6)}ion-header{opacity:1;position:absolute}ion-header.no-title:after{content:none}ion-header.no-title ion-toolbar{--background: rgba(0, 0, 0, 0);background:rgba(0,0,0,0)}ion-footer{position:absolute;bottom:0}ion-footer.no-text:before{content:none}ion-footer.no-text ion-toolbar{--background: rgba(0, 0, 0, 0);background:rgba(0,0,0,0)}#image-viewer-image{position:absolute;top:50%;left:50%;transform:translate(-50%,-50%)}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "component", type: i1.IonButton, selector: "ion-button", inputs: ["buttonType", "color", "disabled", "download", "expand", "fill", "form", "href", "mode", "rel", "routerAnimation", "routerDirection", "shape", "size", "strong", "target", "type"] }, { kind: "component", type: i1.IonButtons, selector: "ion-buttons", inputs: ["collapse"] }, { kind: "component", type: i1.IonContent, selector: "ion-content", inputs: ["color", "forceOverscroll", "fullscreen", "scrollEvents", "scrollX", "scrollY"] }, { kind: "component", type: i1.IonFooter, selector: "ion-footer", inputs: ["collapse", "mode", "translucent"] }, { kind: "component", type: i1.IonHeader, selector: "ion-header", inputs: ["collapse", "mode", "translucent"] }, { kind: "component", type: i1.IonIcon, selector: "ion-icon", inputs: ["color", "flipRtl", "icon", "ios", "lazy", "md", "mode", "name", "sanitize", "size", "src"] }, { kind: "component", type: i1.IonText, selector: "ion-text", inputs: ["color", "mode"] }, { kind: "component", type: i1.IonTitle, selector: "ion-title", inputs: ["color", "size"] }, { kind: "component", type: i1.IonToolbar, selector: "ion-toolbar", inputs: ["color", "mode"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.8", ngImport: i0, type: ViewerModalComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ion-viewer-modal', template: "<ion-header [ngClass]=\"{ 'no-title': title && title.length <= 0 }\">\n  <ion-toolbar>\n    <ion-buttons slot=\"primary\">\n      <ion-button (click)=\"closeModal()\">\n        <ion-icon slot=\"icon-only\" name=\"close\"></ion-icon>\n      </ion-button>\n    </ion-buttons>\n    <ion-title [size]=\"titleSize\">{{ title }}</ion-title>\n  </ion-toolbar>\n</ion-header>\n\n<ion-content [forceOverscroll]=\"false\">\n  <swiper-container [zoom]=\"true\">\n    <swiper-slide>\n      <img id=\"image-viewer-image\" [alt]=\"this.alt\" [src]=\"this.src\"/>\n    </swiper-slide>\n  </swiper-container>\n</ion-content>\n\n<ion-footer [ngClass]=\"{ 'no-text': text && text.length <= 0 }\">\n  <ion-toolbar class=\"ion-text-center\">\n    <ion-text>{{ text }}</ion-text>\n  </ion-toolbar>\n</ion-footer>\n", styles: ["ion-toolbar{--border-style: none;--background: rgba(var(--ion-background-color-rgb, (255, 255, 255)), .6);background:rgba(var(--ion-background-color-rgb, 255, 255, 255),.6)}ion-header{opacity:1;position:absolute}ion-header.no-title:after{content:none}ion-header.no-title ion-toolbar{--background: rgba(0, 0, 0, 0);background:rgba(0,0,0,0)}ion-footer{position:absolute;bottom:0}ion-footer.no-text:before{content:none}ion-footer.no-text ion-toolbar{--background: rgba(0, 0, 0, 0);background:rgba(0,0,0,0)}#image-viewer-image{position:absolute;top:50%;left:50%;transform:translate(-50%,-50%)}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.ModalController }]; }, propDecorators: { alt: [{
                type: Input
            }], scheme: [{
                type: Input
            }], slideOptions: [{
                type: Input
            }], src: [{
                type: Input
            }], srcFallback: [{
                type: Input
            }], srcHighRes: [{
                type: Input
            }], swipeToClose: [{
                type: Input
            }], text: [{
                type: Input
            }], title: [{
                type: Input
            }], titleSize: [{
                type: Input
            }], slides: [{
                type: ViewChild,
                args: ['sliderRef', { static: true }]
            }] } });

// tslint:disable-next-line
class NgxIonicImageViewerComponent {
    constructor(modalController) {
        this.modalController = modalController;
    }
    async viewImage(src, srcFallback = '', srcHighRes = '', title = '', titleSize = '', text = '', scheme = 'auto', slideOptions = {}, swipeToClose = true) {
        const modal = await this.modalController.create({
            component: ViewerModalComponent,
            componentProps: {
                src,
                srcFallback,
                srcHighRes,
                title,
                titleSize,
                text,
                scheme,
                slideOptions,
                swipeToClose
            },
            cssClass: this.cssClass && this.cssClass instanceof Array
                ? ['ion-img-viewer', ...this.cssClass]
                : ['ion-img-viewer', this.cssClass],
            keyboardClose: true,
            showBackdrop: true
        });
        return await modal.present();
    }
    ngOnInit() { }
}
NgxIonicImageViewerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.8", ngImport: i0, type: NgxIonicImageViewerComponent, deps: [{ token: i1.ModalController }], target: i0.ɵɵFactoryTarget.Component });
NgxIonicImageViewerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.8", type: NgxIonicImageViewerComponent, selector: "ion-img-viewer", inputs: { alt: "alt", cssClass: "cssClass", scheme: "scheme", slideOptions: "slideOptions", src: "src", srcFallback: "srcFallback", srcHighRes: "srcHighRes", swipeToClose: "swipeToClose", text: "text", title: "title", titleSize: "titleSize" }, ngImport: i0, template: "<img\n  [alt]=\"alt\"\n  [src]=\"src\"\n  (click)=\"viewImage(src, srcFallback, srcHighRes, title, titleSize, text, scheme, slideOptions, swipeToClose)\"\n  (error)=\"src = srcFallback\"\n/>\n", styles: [":host{display:block}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.8", ngImport: i0, type: NgxIonicImageViewerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ion-img-viewer', encapsulation: ViewEncapsulation.Emulated, template: "<img\n  [alt]=\"alt\"\n  [src]=\"src\"\n  (click)=\"viewImage(src, srcFallback, srcHighRes, title, titleSize, text, scheme, slideOptions, swipeToClose)\"\n  (error)=\"src = srcFallback\"\n/>\n", styles: [":host{display:block}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.ModalController }]; }, propDecorators: { alt: [{
                type: Input
            }], cssClass: [{
                type: Input
            }], scheme: [{
                type: Input
            }], slideOptions: [{
                type: Input
            }], src: [{
                type: Input
            }], srcFallback: [{
                type: Input
            }], srcHighRes: [{
                type: Input
            }], swipeToClose: [{
                type: Input
            }], text: [{
                type: Input
            }], title: [{
                type: Input
            }], titleSize: [{
                type: Input
            }] } });

class NgxIonicImageViewerDirective {
    constructor(el, renderer, modalController) {
        this.el = el;
        this.renderer = renderer;
        this.modalController = modalController;
    }
    onClick() {
        this.viewImage(this.src, this.srcFallback, this.srcHighRes, this.title, this.titleSize, this.text, this.scheme, this.slideOptions, this.swipeToClose);
    }
    onError(error) {
        if (this.src !== this.el.nativeElement.src) {
            this.src = this.el.nativeElement.src;
        }
        if (this.srcFallback) {
            this.renderer.setAttribute(this.el.nativeElement, 'src', this.srcFallback);
        }
    }
    ngOnInit() {
        if (!this.el.nativeElement.hasAttribute('src')) {
            this.renderer.setAttribute(this.el.nativeElement, 'src', this.src);
        }
    }
    async viewImage(src, srcFallback = '', srcHighRes = '', title = '', titleSize = '', text = '', scheme = 'auto', slideOptions = {}, swipeToClose = true) {
        const modal = await this.modalController.create({
            component: ViewerModalComponent,
            componentProps: {
                src,
                srcFallback,
                srcHighRes,
                title,
                titleSize,
                text,
                scheme,
                slideOptions,
                swipeToClose
            },
            cssClass: this.cssClass && this.cssClass instanceof Array
                ? ['ion-img-viewer', ...this.cssClass]
                : ['ion-img-viewer', this.cssClass],
            keyboardClose: true,
            showBackdrop: true
        });
        return await modal.present();
    }
}
NgxIonicImageViewerDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.8", ngImport: i0, type: NgxIonicImageViewerDirective, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }, { token: i1.ModalController }], target: i0.ɵɵFactoryTarget.Directive });
NgxIonicImageViewerDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.2.8", type: NgxIonicImageViewerDirective, selector: "[ionImgViewer]", inputs: { cssClass: "cssClass", scheme: "scheme", slideOptions: "slideOptions", src: "src", srcFallback: "srcFallback", srcHighRes: "srcHighRes", swipeToClose: "swipeToClose", text: "text", title: "title", titleSize: "titleSize" }, host: { listeners: { "click": "onClick()", "error": "onError($event)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.8", ngImport: i0, type: NgxIonicImageViewerDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ionImgViewer]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }, { type: i1.ModalController }]; }, propDecorators: { cssClass: [{
                type: Input
            }], scheme: [{
                type: Input
            }], slideOptions: [{
                type: Input
            }], src: [{
                type: Input
            }], srcFallback: [{
                type: Input
            }], srcHighRes: [{
                type: Input
            }], swipeToClose: [{
                type: Input
            }], text: [{
                type: Input
            }], title: [{
                type: Input
            }], titleSize: [{
                type: Input
            }], onClick: [{
                type: HostListener,
                args: ['click']
            }], onError: [{
                type: HostListener,
                args: ['error', ['$event']]
            }] } });

class NgxIonicImageViewerModule {
}
NgxIonicImageViewerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.8", ngImport: i0, type: NgxIonicImageViewerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgxIonicImageViewerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.2.8", ngImport: i0, type: NgxIonicImageViewerModule, declarations: [NgxIonicImageViewerComponent, NgxIonicImageViewerDirective, ViewerModalComponent], imports: [CommonModule, IonicModule], exports: [NgxIonicImageViewerComponent, NgxIonicImageViewerDirective, ViewerModalComponent] });
NgxIonicImageViewerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.2.8", ngImport: i0, type: NgxIonicImageViewerModule, imports: [CommonModule, IonicModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.8", ngImport: i0, type: NgxIonicImageViewerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgxIonicImageViewerComponent, NgxIonicImageViewerDirective, ViewerModalComponent],
                    imports: [CommonModule, IonicModule],
                    exports: [NgxIonicImageViewerComponent, NgxIonicImageViewerDirective, ViewerModalComponent],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                }]
        }] });

/*
 * Public API Surface of ngx-ionic-image-viewer
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgxIonicImageViewerComponent, NgxIonicImageViewerDirective, NgxIonicImageViewerModule, NgxIonicImageViewerService, ViewerModalComponent };
//# sourceMappingURL=t.simon-ionic-image-viewer.mjs.map
